#!/usr/bin/perl
################################################################################
# WAccess                                      Version 1.1                     #
# Copyright 1999 Frederic TYNDIUK (FTLS)       All Rights Reserved.            #
# E-Mail: tyndiuk@ftls.org                     Script License: GPL             #
# Created  05/30/98                            Last Modified 12/24/99          #
# Scripts Archive at:                          http://www.ftls.org/cgi/        #
################################################################################
# Function :                                                                   #
# Library for WAccess                                                          #
################################################################################
########################## license & copyright header ##########################
#                                                                              #
#                     Copyright (c) 1999 by TYNDIUK Frederic                   #
#                                                                              #
#       This program is free software; you can redistribute it and/or          #
#       modify it under the terms of the GNU General Public License as         #
#       published by the Free Software Foundation; either version 2 of         #
#       the License, or (at your option) any later version.                    #
#                                                                              #
#       This program is distributed in the hope that it will be useful,        #
#       but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#       GNU General Public License for more details.                           #
#                                                                              #
#       You should have received a copy of the GNU General Public License      #
#       along with this program in the file 'COPYING'; if not, write to        #
#       the Free Software Foundation, Inc., 59 Temple Place - Suite 330,       #
#       Boston, MA 02111-1307, USA, or contact the author:                     #
#                                                                              #
#                                   TYNDIUK Frederic <tyndiuk@ftls.org>        #
#                                            <http://www.ftls.org/>            #
#                                                                              #
######################## end license & copyright header ########################
################################################################################
# Necessary Variables:                                                         #
# The following variables should be set to define the locations and URLs of    #
# various files, as explained in the documentation.                            #

	$DATA_DIR = '/Absolute/path/to/datadir/';      # Path of data directory
    $PASSWORD_FILE = $DATA_DIR.'password.txt';     # Name of Password file
	$UNIV_LOGIN = 'FTLS';            # if you have lost your Login/password, Change it...
	$UNIV_PASSWORD = 'www.ftls.org'; # Change it...

	# En: Name and title of Admin Page.
	# Fr: Nom et titre des pages d'administration.
	$ADMIN_FILE = $DATA_DIR.'Admin.html';
	$COMMON_ADMIN_TITLE = 'WAccess v1.1, Administrative Display of www.ftls.org';

	# En: Name and title of Member Page
	# Fr: Nom et titre des pages membres.
	$MEMBER_FILE = $DATA_DIR.'Member.html';
	$COMMON_MEMBER_TITLE = 'Member of www.ftls.org';

	$WEBMASTER_EMAIL = 'you@yourdomain.com';
	
	$DISPLAY_LANG = 'En';
	
# Nothing Below this line needs to be altered!                                 #
#################################################################################
#    DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU'RE DOING    #
################################################################################

require "cgi-lib.pl";

# En: Define all messages and buttons text.
# Fr: Definition des messages et des boutons
if ($DISPLAY_LANG eq 'Fr') {
	%NAME_BUTTON = ('exit' => 'Sortir', 'back' => 'Retour', 'add' => 'Ajouter', 
		'add_user' => 'Ajouter un utilisateur', 'del_user' => 'Supprimer un utilisateur', 
		'chpass' => 'Changer le mot de passe', 'log' => 'Entrer');
	%NAME_HEADTAB = ('name' => 'Nom', 'level' => 'Droits', 'user_page' => 'Page personelle',
		'login' => 'Identifiant', 'password' => 'Mot de passe', 'new_login' => 'Nouvel identifiant',
		'new_pass' => 'Nouveau mot de passe', 'conf_pass' => 'Confimer mot de passe',
		'admin' => 'Administrateur', 'member' => 'Membre');
	%NAME_TITLE   = ('common_admin' => $COMMON_ADMIN_TITLE, 'common_member' => $COMMON_MEMBER_TITLE,
		'error' => 'Erreur', 'manage_users' => 'Management des utilisateurs', 'add_user' => 'Ajout d\'un utilisateur',
		'user_added' => "Nouvel utilisateur 'Value_login' ajout", 'user_deleted' => "Utilisateur 'Value_new_login' supprim",
		'change_pass' => 'Changer votre mot de passe', 'chpass_invalid' => 'Nouveau mot de passe invalide', 'chpass_updated' => 'Mot de passe de Value_login mis  jour',
		'enter_pass' => 'Entrer votre mot de passe', 'invalid_pass' => 'MOT de PASSE INCORECT');
	%HELP_TEXT = ('error_adduser' => 'Le nouveau mot de passe et la confirmation sont diffrents, ou le nouveau mot de passe est identique  l\'ancien...');
} else {
	%NAME_BUTTON = ('exit' => 'Exit', 'back' => 'Back', 'add' => 'Add', 
		'add_user' => 'Add User', 'del_user' => 'Delete user', 
		'chpass' => 'Change Password', 'log' => 'Log in');
	%NAME_HEADTAB = ('name' => 'Name', 'level' => 'Level', 'user_page' => "User page",
		'login' => 'Login', 'password' => 'Password', 'new_login' => 'New Login',
		'new_pass' => 'New password', 'conf_pass' => 'Confim password',
		'admin' => 'Administrator', 'member' => 'Member');
	%NAME_TITLE  = ('common_admin' => $COMMON_ADMIN_TITLE, 'common_member' => $COMMON_MEMBER_TITLE,
		'error' => 'Error', 'manage_users' => 'Manage Users', 'add_user' => 'Add a user',
		'user_added' => "New user 'Value_login' added", 'user_deleted' => "User 'Value_new_login' deleted",
		'change_pass' => 'Change your password', 'chpass_invalid' => 'Invalid new password', 'chpass_updated' => 'Password of Value_login updated',
		'enter_pass' => 'Enter your password', 'invalid_pass' => 'INVALID PASSWORD');
	%HELP_TEXT = ('error_adduser' => 'New password and comfirm password are differents, or new password is the same of old password...');
}

sub CGIProtect {
	my($mode, $login, $password, $title) = @_;
	if (! &check_password($mode, $login, $password)) {
		print &PrintHeader;
		print &BadPassword($title);
		exit;
	}
}

sub CheckAdminMember {
	my($login, $password, $mode, $file) = @_;
	my($title);

	if ($mode eq "root") { $title = $COMMON_ADMIN_TITLE; } else { $title = $COMMON_MEMBER_TITLE; }

	print &PrintHeader;
	if ($login ne "") {
		if (&check_password($mode, $login, $password)) {
			print &ReturnPage($file, $login, $password);
		} else {
			print &BadPassword($title);
		}
		exit;
	}
	print &PagePassword($title);
}


sub ReturnPage {
	my($file, $login, $password) = @_;
	open(COM, "$file") || &Error("Cannot open file : $file, Error: $!");
	$_ = join("",<COM>);
	close(COM);
	s/Value_Password/$password/gi;
	s/Value_Login/$login/gi;
	s/Value_Webmaster_EMail/$WEBMASTER_EMAIL/gi;
	return $_;
}


sub BadPassword {
	$_  = &HTMLHeaderTitle($_[0]);
	$_ .= "<CENTER><BR><BR><B><FONT FACE=\"Arial\" SIZE=\"+3\">$NAME_TITLE{'invalid_pass'}</FONT></B><BR><BR><BR>\n";
	return $_.&BackUrl("","/").&HTMLEnd;
}

sub PagePassword {
    $_ = &HTMLHeaderTitle($_[0]."<BR>$NAME_TITLE{'enter_pass'}");
    $_ .= <<EOF;
<TABLE ALIGN="center" BGCOLOR="navy" BORDER="0" CELLSPACING="0" CELLPADDING="1" WIDTH="50%"><TR><TD>
<TABLE BGCOLOR="#dcdcdc" BORDER="0" CELLSPACING="0" CELLPADDING="3" WIDTH="100%"><TR><TD>
<FORM METHOD=POST>
<TABLE BORDER=0 WIDTH=100% CELLSPACING="10" CELLPADDING="1">
<TR><TD>$NAME_HEADTAB{'login'} :</TD><TD><INPUT TYPE=text NAME=login SIZE=10></TD></TR>
<TR><TD>$NAME_HEADTAB{'password'} :</TD><TD><INPUT TYPE=Password Name=pass SIZE=10></TD>
<TD><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'log'} \" NAME=ok></TD></TR></TABLE>
</FORM>
</TD></TR></TABLE>
</TD></TR></TABLE>
EOF
    $_ .= &HTMLEnd;
    return $_;
}

sub check_password {
	my($mode, $login, $password) = @_;
	my($flogin, $fpass, $flevel, $fpage);

	if (($login  eq $UNIV_LOGIN) && ($password eq $UNIV_PASSWORD)) { return 1; }
	
	if ($mode && $login && $password) {
		open(PASSWORD, $PASSWORD_FILE);
	 	($_) = grep(/^$login\t/, <PASSWORD>);
	  	close(PASSWORD);
		s/\n//;
		($flogin, $fpass, $flevel, $fpage) = split /\t/;

		if ( ($flogin eq $login) && ($fpass eq &CryptPassword($password)) &&
			(($mode eq $flevel) || (($flevel eq "root") && ($mode eq "guest"))) ) {
	    	 return 1;
		}
	}
	return 0;
}

sub CryptPassword {
	return crypt ($_[0], substr($_[0],0,2));
}

sub change_password {
	my($login, $password, %input) = @_;
	my($action, @pass, $flogin, $fpass, $fold, $txt);
	print &PrintHeader;
	if (! &check_password("guest", $login, $password)) {
		print &BadPassword($NAME_TITLE{'common_member'});
		exit;
	}
	$action = "chpass";

	if ($input{'BT_ChPass'}) {
		$NewPass = $input{'NewPass'};
		$ConfNPass = $input{'ConfPass'};
		if (($NewPass eq $ConfNPass) && ($NewPass ne "") && ($password ne $NewPass)) {
			open(PASSWORD, "$PASSWORD_FILE") || &Error("Cannot open password file: $PASSWORD_FILE, Error: $!",1);
			@pass = <PASSWORD>;
			close PASSWORD;
			foreach (@pass) {
				if (/^$login\t/) {
					($flogin, $fpass, $fold) = split(/\t/,$_, 3);
					$_ = "$flogin\t".&CryptPassword($NewPass)."\t$fold";
				}
			}
			open(PASSWORD, ">$PASSWORD_FILE") || &Error("Cannot write password file: $PASSWORD_FILE, Error: $!",1);
			print PASSWORD (@pass);
			close PASSWORD;
			$NAME_TITLE{'chpass_updated'} =~ s/Value_login/$login/gi;
			print &ResutPage("$NAME_TITLE{'common_member'}<BR>$NAME_TITLE{'chpass_updated'}", "", "", $login, $NewPass);
		} else {
			print &ResutPage("$NAME_TITLE{'common_member'}<BR>$NAME_TITLE{'chpass_invalid'}", $HELP_TEXT{'error_adduser'}, $action, $login, $password);
		}
	} else {

	    print &HTMLHeaderTitle("$NAME_TITLE{'common_member'}<BR>$NAME_TITLE{'change_pass'}");
	    print "<CENTER><FORM METHOD=post><TABLE BORDER=0 WIDTH=70%>\n";
    	print "<TR><TD>$NAME_HEADTAB{'login'} :</TD><TD>$login <INPUT TYPE=HIDDEN Name=login value=$login></TD></TR>\n";
	    print "<TR><TD>$NAME_HEADTAB{'password'} :</TD><TD><INPUT TYPE=Password Name=pass value=$password></TD></TR>\n";
   		print "</TABLE><BR><BR><BR><TABLE BORDER=0 WIDTH=70%>";
	    print "<TR><TD>$NAME_HEADTAB{'new_pass'} :</TD><TD><INPUT TYPE=Password Name=NewPass></TD></TR>\n";
    	print "<TR><TD>$NAME_HEADTAB{'conf_pass'} :</TD><TD><INPUT TYPE=Password Name=ConfPass></TD></TR>\n";
	    print "<TD></TD><TD><INPUT TYPE=HIDDEN Name=ac VALUE=\"chpass\"><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'chpass'} \" NAME=\"BT_ChPass\"> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'exit'} \" NAME=BT_Exit></TD></TR>\n";
    	print "</TABLE></CENTER></FORM>\n";
	    print &HTMLEnd;
	}
}

sub ResutPage {
	my($title, $text, $ac, $login, $password) = @_;
	$_ = &HTMLHeaderTitle($title);
	$_ .= "<TABLE WIDTH=\"80%\" ALIGN=\"CENTER\"><TR><TD ALIGN=\"CENTER\">";
	$_ .= "<FONT FACE=\"Arial\" SIZE=\"-1\">$text<P>";
	$_ .= &BackPost("",$ac, $login,$password);
	$_ .= "</FONT>\n</TD></TR></TABLE>";
	$_ .= &HTMLEnd;
	return $_;
}

sub HTMLHeaderTitle {
	return &HTMLHeader($_[0]).&Title($_[0]);
}

sub HTMLHeader {
	my($head_title) = @_;
	$head_title =~ s/\<\w\w*\>/ /g;
    return <<EOF;
<HTML><HEAD><TITLE>$head_title</TITLE>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
<META NAME="ROBOTS" CONTENT="NOINDEX, FOLLOW">
<META NAME="description" content="none">
<META NAME="keywords" content="none">
<META NAME="Author" CONTENT="FTLS (TYNDIUK Frederic, http://www.ftls.org/)">
<META NAME="GENERATOR" CONTENT="CGI Script Made by FTLS"></HEAD>
<BODY BGCOLOR="#FFFFFF">
EOF
}

sub Title {
    return <<EOF;
<BR><BR><P ALIGN="Center"><FONT FACE="Arial, helvetica" SIZE="+2" COLOR="#336699"><STRONG><EM>$_[0]</EM></STRONG></FONT></P><BR>
EOF
}

sub BackPost {
    my($title, $ac, $login, $password) = @_ ;
    if ($title eq "") {
	    $title = $NAME_BUTTON{'back'};
    }
	return "<CENTER><BR><BR><FORM METHOD=post><INPUT TYPE=HIDDEN Name=ac VALUE=$ac><INPUT TYPE=HIDDEN Name=login VALUE=$login><INPUT TYPE=HIDDEN Name=pass VALUE=$password><INPUT TYPE=Submit VALUE=\" $title\" ></FORM><BR><BR></CENTER>\n";
}

sub BackUrl {
    my($title, $url) = @_ ;
    if ($title eq "") {
	    $title = $NAME_BUTTON{'back'};
    }
	return "<CENTER><BR><BR><FONT FACE=\"Arial\"><A HREF=\"$url\">$title</A></FONT><BR><BR></CENTER>\n";
}


sub HTMLEnd {
	# En : Don't change or remove this Copyright.
	# Fr : Ne modifiez pas ni ne supprimez ce Copyright.
    return <<EOF;
<CENTER><BR><BR><FONT FACE="Arial" SIZE="-2">
<EM>&copy Copyright 1999 <A HREF="http://www.ftls.org/">FTLS</A> (Tyndiuk Fr&eacute;d&eacute;ric). All rights reserved.
<BR>FTLS's CGI Scripts Archive : <A HREF="http://www.ftls.org/cgi/">http://www.ftls.org/cgi/</A>.
<BR>Send all comments to <A HREF="mailto:$WEBMASTER_EMAIL">$WEBMASTER_EMAIL</A></EM>.
</FONT></CENTER></BODY></HTML>
EOF
}

sub Error {
	my($errortext, $exit) = @_;
    print &HTMLHeaderTitle($errortext);
	print &HTMLEnd;
	if($exit) { exit; }
}
1; #return true
